# bandwidth
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module Bandwidth
  # CreateCallRequest Model.
  class CreateCallRequest < BaseModel
    # Format is E164
    # @return [String]
    attr_accessor :from

    # Format is E164 or SIP URI
    # @return [String]
    attr_accessor :to

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :uui

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [Float]
    attr_accessor :call_timeout

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [Float]
    attr_accessor :callback_timeout

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :answer_url

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :answer_fallback_url

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :username

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :password

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :fallback_username

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :fallback_password

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [AnswerMethodEnum]
    attr_accessor :answer_method

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [AnswerFallbackMethodEnum]
    attr_accessor :answer_fallback_method

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :disconnect_url

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [DisconnectMethodEnum]
    attr_accessor :disconnect_method

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :tag

    # When calling a SIP URI, this will be sent as the 'User-To-User' header
    # within the initial INVITE. It must end with an 'encoding' parameter as
    # described in https://tools.ietf.org/html/rfc7433. This header cannot
    # exceed 256 characters, including the encoding parameter.
    # @return [String]
    attr_accessor :application_id

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['from'] = 'from'
      @_hash['to'] = 'to'
      @_hash['uui'] = 'uui'
      @_hash['call_timeout'] = 'callTimeout'
      @_hash['callback_timeout'] = 'callbackTimeout'
      @_hash['answer_url'] = 'answerUrl'
      @_hash['answer_fallback_url'] = 'answerFallbackUrl'
      @_hash['username'] = 'username'
      @_hash['password'] = 'password'
      @_hash['fallback_username'] = 'fallbackUsername'
      @_hash['fallback_password'] = 'fallbackPassword'
      @_hash['answer_method'] = 'answerMethod'
      @_hash['answer_fallback_method'] = 'answerFallbackMethod'
      @_hash['disconnect_url'] = 'disconnectUrl'
      @_hash['disconnect_method'] = 'disconnectMethod'
      @_hash['tag'] = 'tag'
      @_hash['application_id'] = 'applicationId'
      @_hash
    end

    def initialize(from = nil,
                   to = nil,
                   answer_url = nil,
                   application_id = nil,
                   uui = nil,
                   call_timeout = nil,
                   callback_timeout = nil,
                   answer_fallback_url = nil,
                   username = nil,
                   password = nil,
                   fallback_username = nil,
                   fallback_password = nil,
                   answer_method = nil,
                   answer_fallback_method = nil,
                   disconnect_url = nil,
                   disconnect_method = nil,
                   tag = nil)
      @from = from
      @to = to
      @uui = uui
      @call_timeout = call_timeout
      @callback_timeout = callback_timeout
      @answer_url = answer_url
      @answer_fallback_url = answer_fallback_url
      @username = username
      @password = password
      @fallback_username = fallback_username
      @fallback_password = fallback_password
      @answer_method = answer_method
      @answer_fallback_method = answer_fallback_method
      @disconnect_url = disconnect_url
      @disconnect_method = disconnect_method
      @tag = tag
      @application_id = application_id
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      from = hash['from']
      to = hash['to']
      answer_url = hash['answerUrl']
      application_id = hash['applicationId']
      uui = hash['uui']
      call_timeout = hash['callTimeout']
      callback_timeout = hash['callbackTimeout']
      answer_fallback_url = hash['answerFallbackUrl']
      username = hash['username']
      password = hash['password']
      fallback_username = hash['fallbackUsername']
      fallback_password = hash['fallbackPassword']
      answer_method = hash['answerMethod']
      answer_fallback_method = hash['answerFallbackMethod']
      disconnect_url = hash['disconnectUrl']
      disconnect_method = hash['disconnectMethod']
      tag = hash['tag']

      # Create object from extracted values.
      CreateCallRequest.new(from,
                            to,
                            answer_url,
                            application_id,
                            uui,
                            call_timeout,
                            callback_timeout,
                            answer_fallback_url,
                            username,
                            password,
                            fallback_username,
                            fallback_password,
                            answer_method,
                            answer_fallback_method,
                            disconnect_url,
                            disconnect_method,
                            tag)
    end
  end
end
